Bug 1739816 - Review Request: redminecli - CLI for Redmine
Summary: Review Request: redminecli - CLI for Redmine
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-NEEDSPONSOR
TreeView+ depends on / blocked
 
Reported: 2019-08-10 19:50 UTC by Ege Güneş
Modified: 2019-09-27 14:48 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Ege Güneş 2019-08-10 19:50:56 UTC
Spec URL: https://copr-be.cloud.fedoraproject.org/results/egegunes/redminecli/fedora-30-x86_64/00997375-redminecli/redminecli.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/egegunes/redminecli/fedora-30-x86_64/00997375-redminecli/redminecli-1.1.3-1.fc30.src.rpm
Description: redminecli is a command line Python application to interact with Redmine
Fedora Account System Username: egegunes
Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=36915934

This is my first package, I need a sponsor.

Comment 1 J. Scheurich 2019-08-16 21:23:50 UTC
This is only a informal review, i am not in the packager group

Rpmlint
-------
Checking: redminecli-1.1.3-1.fc31.x86_64.rpm
          redminecli-1.1.3-1.fc31.src.rpm
redminecli.x86_64: W: no-version-in-last-changelog
redminecli.x86_64: E: no-binary
redminecli.x86_64: W: no-manual-page-for-binary redmine
redminecli.src: W: no-version-in-last-changelog
2 packages and 0 specfiles checked; 1 errors, 3 warnings.

Comment 2 J. Scheurich 2019-08-16 21:26:18 UTC
This is only a informal review, i am not in the packager group

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[ ]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[ ]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 32 files have unknown license. Detailed
     output of licensecheck in /home/mufti/review-
     redminecli/licensecheck.txt
[ ]: %build honors applicable compiler flags or justifies otherwise.
[ ]: Package contains no bundled libraries without FPC exception.
[ ]: Changelog in prescribed format.
[ ]: Sources contain only permissible code or content.
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[ ]: Package uses nothing in %doc for runtime.
[ ]: Package consistently uses macros (instead of hard-coded directory
     names).
[ ]: Package is named according to the Package Naming Guidelines.
[ ]: Package does not generate any conflict.
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Requires correct, justified where necessary.
[ ]: Spec file is legible and written in American English.
[ ]: Package contains systemd file(s) if in need.
[ ]: Useful -debuginfo package or justification otherwise.
[ ]: Package is not known to require an ExcludeArch tag.
[ ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[ ]: Python eggs must not download any dependencies during the build
     process.
[ ]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: redminecli-1.1.3-1.fc31.x86_64.rpm
          redminecli-1.1.3-1.fc31.src.rpm
redminecli.x86_64: W: no-version-in-last-changelog
redminecli.x86_64: E: no-binary
redminecli.x86_64: W: no-manual-page-for-binary redmine
redminecli.src: W: no-version-in-last-changelog
2 packages and 0 specfiles checked; 1 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
redminecli.x86_64: W: no-version-in-last-changelog
redminecli.x86_64: W: invalid-url URL: https://github.com/egegunes/redmine-cli <urlopen error [Errno -2] Name or service not known>
redminecli.x86_64: E: no-binary
redminecli.x86_64: W: no-manual-page-for-binary redmine
1 packages and 0 specfiles checked; 1 errors, 3 warnings.



Source checksums
----------------
https://files.pythonhosted.org/packages/d4/29/c9fbd0b0beb707ad39a2028eb7feda7301e78e88af9de70ee637c93778e0/redminecli-1.1.3.tar.gz :
  CHECKSUM(SHA256) this package     : b954b9ea29143af849a6f28077ab87b87591b2bb96805fbeff1f08feedcf424c
  CHECKSUM(SHA256) upstream package : b954b9ea29143af849a6f28077ab87b87591b2bb96805fbeff1f08feedcf424c


Requires
--------
redminecli (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3
    python3.7dist(click)
    python3.7dist(colorama)
    python3.7dist(requests)
    python3.7dist(setuptools)



Provides
--------
redminecli:
    python3.7dist(redminecli)
    python3dist(redminecli)
    redminecli
    redminecli(x86-64)



Generated by fedora-review 0.7.2 (65d36bb) last change: 2019-04-09
Command line :/bin/fedora-review -n redminecli
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Python, Generic
Disabled plugins: C/C++, Ocaml, fonts, Perl, SugarActivity, Java, R, Haskell, PHP
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 3 Robert-André Mauchin 🐧 2019-08-23 15:13:50 UTC
(In reply to J. Scheurich from comment #2)
> This is only a informal review, i am not in the packager group
> 

You're supposed to fill the blanks [ ] otherwise it's not useful. You haven't added your own comments either.


 - %global debug_package %{nil}

No, this is a Python package, it should be marked as noarch instead:

BuildArch:      noarch

 - Don't use PythonHosted for Source:

Source0:        %{pypi_source}

 - Not needed:

Requires:       python3

 - Bump to 1.1.4

 - Your changelog entry must contain Version-Release info:

* Sat Aug 10 2019 Ege Güneş <egegunes@gmail.com> - 1.1.4-1

 - Add a dot at the end of the description:

%description
Redminecli is a command line interface for Redmine.

 - LICENSE file mist be installed with %license in %files:

%files
%doc README.md
%license LICENSE

 - The archive contains tests, consider running them in %check.

You might need to do a sed -i "s|os.mkdir|os.makedirs|" redmine/redmine.py in your code as .cache does not exist by default in the chroot.


BuildRequires:  python3-pytest

[…]

%check
%{__python3} -m pytest





Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 32 files have unknown license. Detailed
     output of licensecheck in
     /home/bob/packaging/review/redminecli/review-
     redminecli/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: redminecli-1.1.4-1.fc32.noarch.rpm
          redminecli-1.1.4-1.fc32.src.rpm
redminecli.noarch: W: no-manual-page-for-binary redmine
2 packages and 0 specfiles checked; 0 errors, 1 warnings.

Comment 5 Robert-André Mauchin 🐧 2019-08-28 20:29:33 UTC
 - That's not needed, the file should be in licensedir

%{_docdir}/redminecli/LICENSE

 - Add a nemline between your changelog entry

 - You haven't added the tests?

Comment 6 Ege Güneş 2019-08-29 08:04:01 UTC
(In reply to Robert-André Mauchin from comment #5)
>  - That's not needed, the file should be in licensedir
> 
> %{_docdir}/redminecli/LICENSE
> 

The setup.py script tries to install license to `sys.prefix` (`/usr`) if include it in the dist. I couldn't see any macro that points to default licensedir. Can you point me the right direction?

>  - You haven't added the tests?

Tests confused me because Python Packaging Docs[1] explicitly says "Python modules must not download any dependencies during the build process.". But I need to download the packages' dependencies to test it? Am I missing something?

[1] https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_reviewer_checklist

Comment 7 Robert-André Mauchin 🐧 2019-08-29 12:22:00 UTC
(In reply to Ege Güneş from comment #6)
> (In reply to Robert-André Mauchin from comment #5)
> >  - That's not needed, the file should be in licensedir
> > 
> > %{_docdir}/redminecli/LICENSE
> > 
> 
> The setup.py script tries to install license to `sys.prefix` (`/usr`) if
> include it in the dist. I couldn't see any macro that points to default
> licensedir. Can you point me the right direction?

mv it to %{_defaultlicensedir} if needed or exclide it with %exclude

> 
> >  - You haven't added the tests?
> 
> Tests confused me because Python Packaging Docs[1] explicitly says "Python
> modules must not download any dependencies during the build process.". But I
> need to download the packages' dependencies to test it? Am I missing
> something?
> 
> [1]
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/
> #_reviewer_checklist

If there is some needed deps, add them as BR. But I ran the tests with no issues without any added BR:

+ /usr/bin/python3 -m pytest
============================= test session starts ==============================
platform linux -- Python 3.8.0b3, pytest-4.6.5, py-1.8.0, pluggy-0.12.0
rootdir: /builddir/build/BUILD/redminecli-1.1.4
collected 20 items
tests/api/test_fetch.py .....                                            [ 25%]
tests/api/test_get.py ..........                                         [ 75%]
tests/ui/test_priority.py .                                              [ 80%]
tests/ui/test_project.py .                                               [ 85%]
tests/ui/test_query.py .                                                 [ 90%]
tests/ui/test_tracker.py .                                               [ 95%]
tests/ui/test_user.py .                                                  [100%]
========================== 20 passed in 0.72 seconds ===========================

Comment 8 Ege Güneş 2019-09-26 21:11:13 UTC
(In reply to Robert-André Mauchin from comment #7)
> (In reply to Ege Güneş from comment #6)
> > (In reply to Robert-André Mauchin from comment #5)
> > >  - That's not needed, the file should be in licensedir
> > > 
> > > %{_docdir}/redminecli/LICENSE
> > > 
> > 
> > The setup.py script tries to install license to `sys.prefix` (`/usr`) if
> > include it in the dist. I couldn't see any macro that points to default
> > licensedir. Can you point me the right direction?
> 
> mv it to %{_defaultlicensedir} if needed or exclide it with %exclude
> 

I excluded the license from dist.

> > 
> > >  - You haven't added the tests?
> > 
> > Tests confused me because Python Packaging Docs[1] explicitly says "Python
> > modules must not download any dependencies during the build process.". But I
> > need to download the packages' dependencies to test it? Am I missing
> > something?
> > 
> > [1]
> > https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/
> > #_reviewer_checklist
> 
> If there is some needed deps, add them as BR. But I ran the tests with no
> issues without any added BR:
> 

Tests require python3-pytest, python3-click and python3-requests to run. I built the rpm with tests successfully on my machine, because I had these packages already installed on my system. Maybe you had those too? Anyway I added them as BR.

 
Spec URL: https://copr-be.cloud.fedoraproject.org/results/egegunes/redminecli/fedora-30-x86_64/01040882-redminecli/redminecli.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/egegunes/redminecli/fedora-30-x86_64/01040882-redminecli/redminecli-1.1.8-1.fc30.src.rpm
Latest Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=37882269

Comment 9 Robert-André Mauchin 🐧 2019-09-27 14:48:15 UTC
LGTM, package approved.


You still need to find a sponsor.
See https://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group


Note You need to log in before you can comment on or make changes to this bug.